/***************************************************************************
 *   Copyright (C) 2004-2008 by Pere Constans
 *   constans@molspaces.com
 *   cb2Bib version 0.9.4
 *   See the LICENSE file that comes with this distribution
 *
 *   Class implementation of the approximate search algorithm
 *   P. Constans. Approximate textual retrieval. arXiv:0705.0751v1, 2007.
 ***************************************************************************/
#ifndef C2BAPPROXIMATEPATTERN_H
#define C2BAPPROXIMATEPATTERN_H

#include <QRegExp>
#include <QStringList>


class c2bApproximatePattern
{

public:
    c2bApproximatePattern(const QString newPattern, Qt::CaseSensitivity newCs);
    ~c2bApproximatePattern();

    const QRegExp toRegExp();


private:
    const QString escape(const QString& str, Qt::CaseSensitivity cs);
    const QStringList splitWord(const QString& word);
    const QString wordPattern(const QString& word, Qt::CaseSensitivity cs);
    int stretch(int piece_i, int piece_j);
    int wordCount(const QString& str);
    QList<int> ppEnds;
    QList<int> ppStarts;
    QRegExp arx;
    QStringList patternPieces;
    QStringList pre;
    QStringList suf;
    QString pattern;
    void setPattern();
    void splitPattern();

};

#endif
