/***************************************************************************
 *   Copyright (C) 2004-2008 by Pere Constans
 *   constans@molspaces.com
 *   cb2Bib version 0.9.4
 *   See the LICENSE file that comes with this distribution
 ***************************************************************************/
#ifndef C2BBIBPREPARSER_H
#define C2BBIBPREPARSER_H

#include <QObject>


class QProcess;
class c2bBibPreparser_Log;
class c2bSettings;
class cb2bibbase;


/*!
    This class handles external processing of Bibliographic items. It's
    formally an extension of the c2bBibParser, the glue class between GUI staff
    and the cb2Bib's bibParser functionality.

*/
class c2bBibPreparser : public QObject
{

    Q_OBJECT

public:
    c2bBibPreparser(QObject *parent = 0);
    ~c2bBibPreparser();


signals:
    void preParserDataAvailable(const QString& ppItem);


public slots:
    void preParseItem(const QString& cb);


protected slots:
    void conversionEnded();


private:
    QProcess *preParser;
    QString inp_string;
    QString m_inp_file;
    QString m_out_file;
    QString out_string;
    QWidget* c2bMain;
    c2bBibPreparser_Log* viewLog;
    c2bSettings *settings;
    void preProcess();

};

#endif
