/***************************************************************************
 *   Copyright (C) 2004-2008 by Pere Constans
 *   constans@molspaces.com
 *   cb2Bib version 0.9.4
 *   See the LICENSE file that comes with this distribution
 ***************************************************************************/
#include "c2bBibPreparser_Log.h"
#include "c2b.h"
#include "c2bSettings.h"

#include <QCloseEvent>
#include <QFileInfo>
#include <QProcess>
#include <QPushButton>


c2bBibPreparser_Log::c2bBibPreparser_Log(QWidget *parent) : QDialog(parent)
{
    ui.setupUi(this);
    connect(ui.buttonBox, SIGNAL(helpRequested()), this, SLOT(help()));
    ui.Logs->setReadOnly(true);
}

c2bBibPreparser_Log::~c2bBibPreparser_Log()
{}


void c2bBibPreparser_Log::append(const QString& ms)
{
    ui.Logs->append(ms);
}

void c2bBibPreparser_Log::closeEvent(QCloseEvent* ce)
{
    ui.Logs->clear();
    if (ui.PreparserShowLog->isChecked())
        c2bSettingsP->setValue("cb2Bib/PreparserShowLog", false);
    ui.PreparserShowLog->setChecked(false);
    ce->accept();
}

void c2bBibPreparser_Log::readLog(QProcess *ep)
{
    ui.Logs->clear();
    ui.Logs->append(QString::fromUtf8(ep->readAllStandardOutput()));
    ui.Logs->append(QString::fromUtf8(ep->readAllStandardError()));
    ui.buttonBox->button(QDialogButtonBox::Close)->setFocus();
}

void c2bBibPreparser_Log::help()
{
    c2b::displayHelp("http://www.molspaces.com/d_cb2bib-overview.php#keyboard");
}
