/***************************************************************************
 *   Copyright (C) 2004-2008 by Pere Constans
 *   constans@molspaces.com
 *   cb2Bib version 0.9.4
 *   See the LICENSE file that comes with this distribution
 ***************************************************************************/
#include "c2bRL_webSearchSettings.h"
#include "c2bSettings.h"


c2bRL_webSearchSettings::c2bRL_webSearchSettings(QWidget* parent) : QDialog(parent)
{
    ui.setupUi(this);
    resize(size().width(), 1);
    c2bSettings* settings = c2bSettingsP;
    QString searchEngine = settings->value("c2bReferenceList/SearchEngine").toString();
    ui.searchEngine->addItem(searchEngine);
    ui.searchEngine->addItem("http://www.google.com/search?ie=UTF-8&q=");
    ui.searchEngine->addItem("http://scholar.google.com/scholar?ie=UTF-8&q=");
    ui.searchEngine->setCurrentIndex(0);
    ui.searchEngine->setFocus();
    ui.addQuotes->setChecked(settings->value("c2bReferenceList/SearchEngineAddQuotes").toBool());
}

c2bRL_webSearchSettings::~c2bRL_webSearchSettings()
{}


void c2bRL_webSearchSettings::accept()
{
    c2bSettings* settings = c2bSettingsP;
    settings->setValue("c2bReferenceList/SearchEngine", ui.searchEngine->currentText());
    settings->setValue("c2bReferenceList/SearchEngineAddQuotes", ui.addQuotes->isChecked());
    QDialog::accept();
}
