/***************************************************************************
 *   Copyright (C) 2004-2008 by Pere Constans
 *   constans@molspaces.com
 *   cb2Bib version 0.9.4
 *   See the LICENSE file that comes with this distribution
 ***************************************************************************/
#ifndef C2BTEXTEDIT_H
#define C2BTEXTEDIT_H

#include <QTextEdit>


class QAction;
class QMenu;


class c2bTextEdit : public QTextEdit
{
    Q_OBJECT
public:
    c2bTextEdit(QWidget *parent = 0);
    ~c2bTextEdit();

    QAction* convertSelection2LaTeXAction;
    QAction* convertSelection2UnicodeAction;
    QAction* journalsToAbbreviatedAction;
    QAction* journalsToFullAction;
    QAction* pasteCurrentBibTeXAction;
    QAction* wordUnWrapAction;
    QAction* wordWrapAction;
    QString editFileName() const;
    void setBibTeXActions();
    void setEditFileName(const QString& fn);


signals:
    void overwriteModeChanged();


public slots:
    void updatePlainText(const QString& text);
    void wordUnWrap();
    void wordWrap();


protected slots:
    void convert2LaTeX();
    void convert2Unicode();


protected:
    void contextMenuEvent(QContextMenuEvent * e);
    void keyPressEvent(QKeyEvent * e);


private:
    QString edit_file_name;

};

#endif
